


<template>
  <div>
    <button v-for="input in slide.inputs" type="button" @click="click(input)" class="btn btn-primary">{{ input.button }}</button>
  </div>
</template>

<script>
  import Store from '../stores/app.store';
  export default {
    name: "survey-input-buttons",
    props: [ 'name' ],
    data: function() {
      var self = this;
      var slide = Store.getters.slide(this.name);
      var controls = slide.inputs || [];
      if (!controls || !controls.length) { return null; }

      function checkDefault() {
        if (slide.selection) {
          for (var i = 0; i < controls.length; i++) {
            if (controls[i].option == slide.selection) {
              self.click(controls[i]);
              return controls[i].option;
            }
          }
        }
        for (var i = 0; i < controls.length; i++) {
          if (controls[i].defaultIf == 'always') {
            self.click(controls[i]);
            return controls[i].option;
          } else if (controls[i].defaultIf) {
            if (Store.survey.meta[controls[i].defaultIf]) {
              self.click(controls[i]);
              return controls[i].option;
            }
          }
        }
        return null;
      }

      return {
        slide: slide,
        defaultChecked: checkDefault()
      };
    },
    methods: {
      click: function(input) {
        var value = 0;

        if (input.addValue)
          value += input.addValue;

        if (input.subtractValue)
          value -= input.subtractValue;

        Store.commit('updateSlide', {
          name: this.name,
          selection: input.option,
          text: input.changeText,
          valueNote: input.changeValueNote,
          footnote: input.chanageFootnote,
          meta: input.addMeta,
          next: input.next || Store.state.survey.slidesArray[Store.state.survey.currentSlideIndex + 1],
          runningValue: value
        });

        if (input.addMeta) {
          Store.commit('addMeta', input.addMeta);
        }

        Store.commit('nextSlide');
      }
    }
  }
</script>

<style scoped>
  button {
    margin: 1em .5em;
    padding: .3em 2em;
    border-radius: 1em;
    text-transform: uppercase;
  }
</style>
